/*------------------------------
   RASTER.C -- Raster Font Demo
  ------------------------------*/

#define INCL_WIN
#define INCL_GPI
#include <os2.h>
#include <string.h>
#include "text.h"
#include "easyfont.h"
#define LCID_MYFONT 1L

MRESULT EXPENTRY ClientWndProc (HWND, USHORT, MPARAM, MPARAM) ;

HAB  hab ;

int main (void)
     {
     static CHAR    szClientClass [] = "Raster" ;
     static ULONG   flFrameFlags = FCF_TITLEBAR      | FCF_SYSMENU |
                                   FCF_SIZEBORDER    | FCF_MINMAX  |
                                   FCF_SHELLPOSITION | FCF_TASKLIST ;
     HMQ            hmq ;
     HWND           hwndFrame, hwndClient ;
     QMSG           qmsg ;

     hab = WinInitialize (0) ;
     hmq = WinCreateMsgQueue (hab, 0) ;

     WinRegisterClass (hab, szClientClass, ClientWndProc, CS_SIZEREDRAW, 0) ;

     hwndFrame = WinCreateStdWindow (HWND_DESKTOP, WS_VISIBLE,
                                     &flFrameFlags, szClientClass, NULL,
                                     0L, NULL, 0, &hwndClient) ;

     WinSendMsg (hwndFrame, WM_SETICON,
                 WinQuerySysPointer (HWND_DESKTOP, SPTR_APPICON, FALSE),
                 NULL) ;

     while (WinGetMsg (hab, &qmsg, NULL, 0, 0))
          WinDispatchMsg (hab, &qmsg) ;

     WinDestroyWindow (hwndFrame) ;
     WinDestroyMsgQueue (hmq) ;
     WinTerminate (hab) ;
     return 0 ;
     }

MRESULT EXPENTRY ClientWndProc (HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2)
     {
     static HPS    hps ;
     static SHORT  sNumLines = sizeof aszText / sizeof aszText[0] ;
     static SIZEL  sizlClient ;
     FONTMETRICS   fm ;
     HDC           hdc ;
     POINTL        ptl ;
     SHORT         i ;
     SIZEL         sizlPage ;

     switch (msg)
          {
          case WM_CREATE:
               hdc = WinOpenWindowDC (hwnd) ;
               sizlPage.cx = 0 ;
               sizlPage.cy = 0 ;
               hps = GpiCreatePS (hab, hdc, &sizlPage,
                                  PU_PELS    | GPIF_DEFAULT |
                                  GPIT_MICRO | GPIA_ASSOC) ;

               EzfQueryFonts (hps) ;
               return 0 ;

          case WM_SIZE:
               sizlClient.cx = SHORT1FROMMP (mp2) ;
               sizlClient.cy = SHORT2FROMMP (mp2) ;
               return 0 ;

          case WM_PAINT:
               WinBeginPaint (hwnd, hps, NULL) ;
               GpiErase (hps) ;

               EzfCreateLogFont (hps, LCID_MYFONT, FONTFACE_TIMES,
                                 FONTSIZE_10, 0) ;

               GpiSetCharSet (hps, LCID_MYFONT) ;
               GpiQueryFontMetrics (hps, (LONG) sizeof fm, &fm) ;

               ptl.x = fm.lAveCharWidth ;
               ptl.y = sizlClient.cy - fm.lMaxBaselineExt + fm.lMaxDescender ;

               for (i = 0 ; i < sNumLines ; i++)
                    {
                    GpiCharStringAt (hps, &ptl, (LONG) strlen (aszText[i]),
                                     aszText[i]) ;

                    ptl.y -= fm.lMaxBaselineExt ;
                    }

               GpiSetCharSet (hps, LCID_DEFAULT) ;
               GpiDeleteSetId (hps, LCID_MYFONT) ;
               WinEndPaint (hps) ;
               return 0 ;

          case WM_DESTROY:
               GpiDestroyPS (hps) ;
               return 0 ;
          }
     return WinDefWindowProc (hwnd, msg, mp1, mp2) ;
     }
